//+------------------------------------------------------------------+
//|                                   luktom visual order editor.mq4 |
//|                                   luktom :: ukasz Tomaszkiewicz |
//|                                               http://luktom.biz/ |
//+------------------------------------------------------------------+
#property copyright "luktom :: ukasz Tomaszkiewicz"
#property link      "http://luktom.biz/"

#include <stderror.mqh>
#include <stdlib.mqh>
#define  NL    "\n"

extern bool  use_timer=false;

extern int    default_sl_level=7;
extern int    default_tp_level=20;

extern color  sl_color=Orange;
extern int    sl_style=STYLE_DASH;
extern color  tp_color=DarkGray;
extern int    tp_style=STYLE_DASH;
extern color  be_color=Brown;
extern int    be_style=STYLE_DASH;
extern int    be_offset=1;
extern color  cl_color=Purple;
extern int    cl_style=STYLE_DASH;

extern bool   use_cp=true;
extern color  cp_color=Pink;
extern int    cp_style=STYLE_DASH;
extern int    cp_level=0;
extern int    cp_closedlevel=20;
extern double cp_lots=0;

extern color ol_sell_color=Red;
extern int   ol_sell_style=STYLE_DASH;
extern color ol_buy_color=Blue;
extern int   ol_buy_style=STYLE_DASH;

extern bool  use_be=true;
extern int   default_be_level=7;

extern bool  use_cl=true;
extern int   default_cl_level=20;

extern bool  delete_on_deinit=true;

int               CountedTrades;//Keeps a count of open trades
double            OpenTradesUpl;
int               BuysOpen;
double            BuyTradesUpl;
double            BuyLotTotals;
double            BuyPercentOfBalance;
int               SellsOpen;
double            SellTradesUpl;
double            SellLotTotals;
double            SellPercentOfBalance;
extern bool       Show_Settings  = true;

double i;
int m,s,k;
extern string     myFont   = "Impact" ;// "Eras Bold ITC"
extern int        myFontSize  = 24 ;
extern color      colorTime = White ;

datetime          CurrentTime;
string            ScreenMessage;
string            Gap;
int               pipMult;

void DisplayUserFeedback()
{
   ScreenMessage = "";   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lots = ", OrderLots(),NL);   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Current Spread = ",MarketInfo(Symbol(),MODE_SPREAD)/pipMult," Pips",NL);
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Total trades open = ", CountedTrades, ": Upl = ", DoubleToStr(OpenTradesUpl,2),NL);
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Buy trades = ", BuysOpen, ": Upl = ", DoubleToStr(BuyTradesUpl,2));
   if (BuyTradesUpl != 0)
   {
      ScreenMessage = StringConcatenate(ScreenMessage, ": Upl(Pips) = ", (Bid-FindLastBuyPrice())/(Point*pipMult), "   (", DoubleToStr(BuyPercentOfBalance,2), "% of balance)");
   }
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Total buy lots open = ", BuyLotTotals, NL);

   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Sell trades = ", SellsOpen, ": Upl = ", DoubleToStr(SellTradesUpl,2));
   if (SellTradesUpl != 0)
   {
      ScreenMessage = StringConcatenate(ScreenMessage, ": Upl(Pips) = ",(FindLastSellPrice()-Ask)/(Point*pipMult), "   (", DoubleToStr(SellPercentOfBalance,2), "% of balance)");
   }
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Total sell lots open = ", SellLotTotals, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, NL);  
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Last Sell Price : ",DoubleToStr(FindLastSellPrice(),Digits),NL);   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Last Buy Price : ",DoubleToStr(FindLastBuyPrice(),Digits),NL);   
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
   if (OrderType() == OP_BUY)  ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Take Profit Gap (Pips) : ",(FindLastTP()-FindLastBuyPrice())/(Point*pipMult),NL);
   if (OrderType() == OP_SELL) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Take Profit Gap (Pips) : ",(FindLastSellPrice()-FindLastTP())/(Point*pipMult),NL);
   if (OrderType() == OP_BUY)  ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Stop Loss Gap (Pips) : ",(FindLastBuyPrice()-FindLastStopLoss())/(Point*pipMult),NL);
   if (OrderType() == OP_SELL) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Stop Loss Gap (Pips) : ",(FindLastStopLoss()-FindLastSellPrice())/(Point*pipMult),NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Current Candle Body Size (pips)   : ",MathAbs(Open[0]-Close[0])/(Point*pipMult),NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Previous Candle Body Size (pips)   : ",MathAbs(Open[1]-Close[1])/(Point*pipMult),NL);
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
   ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Local Time = ", TimeHour(TimeLocal()), NL);
   ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Bar Will Be End In : "+m+" m "+s+" s ",NL);
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
   Comment(ScreenMessage);   
}//End void DisplayUserFeedback()

void init() {
 
 if(use_timer) {  timer(); }

if (Digits==3 || Digits==5) 
pipMult = 10;
else  pipMult = 1; 
default_be_level=default_be_level*pipMult;
default_cl_level=default_cl_level*pipMult;
cp_closedlevel=cp_closedlevel*pipMult;
default_tp_level=default_tp_level*pipMult;
default_sl_level=default_sl_level*pipMult;
be_offset=be_offset*pipMult;

   for (int cc = 0; cc < 225; cc++)
   {
      Gap = StringConcatenate(Gap, " ");
   }
 
}


void timer() {

   while(true) {
    Sleep(1000);
     
    if(IsStopped()) {
     return;
    }
    
    start();
   }
   
}

void CountOpenTrades()
{
   //Calculates the number of trades already open

   CountedTrades = 0;
   OpenTradesUpl=0;
   BuysOpen=0;
   BuyLotTotals=0;
   BuyTradesUpl=0;
   SellsOpen=0;
   SellTradesUpl=0;
   SellLotTotals=0;

   if (OrdersTotal()==0) return(0);//Nothing to do
   
   for (int cc = OrdersTotal()-1; cc >=0; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS) ) continue;
      if (OrderSymbol() == Symbol()) 
      {
         CountedTrades++;
         OpenTradesUpl+= OrderProfit();     
         if (OrderType() == OP_BUY)
         {
            BuysOpen++;
            BuyTradesUpl+= OrderProfit();
            BuyLotTotals+= OrderLots();
         }//if (OrderType() == OP_BUY
         
         if (OrderType() == OP_SELL)
         {
            SellsOpen++;
            SellTradesUpl+= OrderProfit();
            SellLotTotals+= OrderLots();
         }//if (OrderType() == OP_SELL
             
      }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)   
   
   }//for (int cc = OrdersTotal(); cc >=0; cc--)  

   double PcCalculator = BuyTradesUpl;
   if (PcCalculator < 0) PcCalculator*= -1;
   BuyPercentOfBalance = (PcCalculator / AccountBalance() ) * 100;
   
   PcCalculator = SellTradesUpl;
   if (PcCalculator < 0) PcCalculator*= -1;   
   SellPercentOfBalance = (PcCalculator / AccountBalance() ) * 100;
   
}//End void CountOpenTrades()

double FindLastStopLoss() 
  {
   double LastStopLoss;
   int CurrentOrderTicket;
   double NewStopLoss = 0;
   int NewOrderTicket = 0;
   for (int dd = OrdersTotal() - 1; dd >= 0; dd--) 
       {
        OrderSelect(dd, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol() != Symbol()) continue;
        if (OrderSymbol() == Symbol()) 
           {
            CurrentOrderTicket = OrderTicket();
            if (CurrentOrderTicket > NewOrderTicket) 
               {
                LastStopLoss = OrderStopLoss();
                NewStopLoss = LastStopLoss;
                NewOrderTicket = CurrentOrderTicket;
               }
           }
       }
   return (NormalizeDouble(LastStopLoss,Digits));
  }

double FindLastTP() 
  {
   double LastTP;
   int CurrentOrderTicket;
   double NewTP = 0;
   int NewOrderTicket = 0;
   for (int dd = OrdersTotal() - 1; dd >= 0; dd--) 
       {
        OrderSelect(dd, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol() != Symbol()) continue;
        if (OrderSymbol() == Symbol()) 
           {
            CurrentOrderTicket = OrderTicket();
            if (CurrentOrderTicket > NewOrderTicket) 
               {
                LastTP = OrderTakeProfit();
                NewTP = LastTP;
                NewOrderTicket = CurrentOrderTicket;
               }
           }
       }
   return (NormalizeDouble(LastTP,Digits));
  }
  
double FindLastBuyPrice() 
  {
   double LastBuyPrice;
   int CurrentOrderTicket;
   double NewBuyPrice = 0;
   int NewOrderTicket = 0;
   for (int dd = OrdersTotal() - 1; dd >= 0; dd--) 
       {
        OrderSelect(dd, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol() != Symbol()) continue;
        if (OrderSymbol() == Symbol() && OrderType() == OP_BUY) 
           {
            CurrentOrderTicket = OrderTicket();
            if (CurrentOrderTicket > NewOrderTicket) 
               {
                LastBuyPrice = OrderOpenPrice();
                NewBuyPrice = LastBuyPrice;
                NewOrderTicket = CurrentOrderTicket;
               }
           }
       }
   return (LastBuyPrice);
  }

double FindLastSellPrice() 
  {
   double LastSellPrice;
   int CurrentOrderTicket;
   double NewSellPrice = 0;
   int NewOrderTicket = 0;
   for (int dd = OrdersTotal() - 1; dd >= 0; dd--) 
       {
        OrderSelect(dd, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol() != Symbol()) continue;
        if (OrderSymbol() == Symbol()&& OrderType() == OP_SELL) 
           {
            CurrentOrderTicket = OrderTicket();
            if (CurrentOrderTicket > NewOrderTicket) 
               {
                LastSellPrice = OrderOpenPrice();
                NewSellPrice = LastSellPrice;
                NewOrderTicket = CurrentOrderTicket;
               }
           }
       }
   return (LastSellPrice);
  }        
void deinit() {
 
 if(delete_on_deinit) {
  for(int i=0;i<ObjectsTotal();i++) {
   string name=ObjectName(i);
  
   if(StringSubstr(name,0,4)=="lvoe") {
    ObjectDelete(name);
   }
  }
 }
   
}

void start() {

   double LotNormaliser;
   m=Time[0]+Period()*60-TimeCurrent();
   i=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
   
   if (Show_Settings)  DisplayUserFeedback();
   RefreshRates(); CountOpenTrades();//Counts the number of open trades   
   FindLastSellPrice(); FindLastBuyPrice();
   

   for(int i=0; i<OrdersTotal();i++) {
    if(OrderSelect(i,SELECT_BY_POS)) {
     if(OrderSymbol()==Symbol()) {
      int dgts=MarketInfo(OrderSymbol(),MODE_DIGITS);
      
      if(ObjectFind("lvoe_ol_" + OrderTicket())==-1) {
       
       if(OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP) { 
        ObjectCreate("lvoe_ol_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderOpenPrice());
        ObjectSet("lvoe_ol_" + OrderTicket(),OBJPROP_COLOR,ol_sell_color); 
        ObjectSet("lvoe_ol_" + OrderTicket(),OBJPROP_STYLE,ol_sell_style); 
       }
       
       if(OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) {
        ObjectCreate("lvoe_ol_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderOpenPrice());
        ObjectSet("lvoe_ol_" + OrderTicket(),OBJPROP_COLOR,ol_buy_color); 
        ObjectSet("lvoe_ol_" + OrderTicket(),OBJPROP_STYLE,ol_buy_style); 
       }
       
      } else {
       
       if(OrderType()==OP_SELL || OrderType()==OP_BUY) {
        ObjectDelete("lvoe_ol_" + OrderTicket());
       }
       
       align("lvoe_ol_" + OrderTicket());
       
       if(NormalizeDouble(OrderOpenPrice(),dgts)!=NormalizeDouble(ObjectGet("lvoe_ol_" + OrderTicket(),OBJPROP_PRICE1),dgts)) {
        if(!OrderModify(OrderTicket(),ObjectGet("lvoe_ol_" + OrderTicket(),OBJPROP_PRICE1),OrderStopLoss(),OrderTakeProfit(),OrderExpiration(),CLR_NONE)) {
         //Alert(ErrorDescription(GetLastError()));
        }
        continue;
       }
       
      }
      
      if(OrderStopLoss()>0 || default_sl_level>0) {
       if(ObjectFind("lvoe_sl_" + OrderTicket())==-1) {
       
        if(OrderStopLoss()==0) {
         ObjectCreate("lvoe_sl_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderOpenPrice()-orderDir(OrderType())*default_sl_level*Point);
        } else {
         ObjectCreate("lvoe_sl_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderStopLoss());
        }
        ObjectSet("lvoe_sl_" + OrderTicket(),OBJPROP_COLOR,sl_color); 
        ObjectSet("lvoe_sl_" + OrderTicket(),OBJPROP_STYLE,sl_style); 
        ObjectSetText("lvoe_sl_" + OrderTicket(),"#"+OrderTicket()+" stop loss",11);
       
       } else {
        align("lvoe_sl_" + OrderTicket());
        if(NormalizeDouble(OrderStopLoss(),dgts)!=NormalizeDouble(ObjectGet("lvoe_sl_" + OrderTicket(),OBJPROP_PRICE1),dgts)) {
         if(!OrderModify(OrderTicket(),OrderOpenPrice(),ObjectGet("lvoe_sl_" + OrderTicket(),OBJPROP_PRICE1),OrderTakeProfit(),OrderExpiration(),CLR_NONE)) {
          //Alert(ErrorDescription(GetLastError()));
         }
         continue;
        }
        
       }  
      } else {
       if(ObjectFind("lvoe_sl_" + OrderTicket())!=-1) {
        ObjectDelete("lvoe_sl_" + OrderTicket());
       }
      }
      
      if(OrderTakeProfit()>0 || default_tp_level) {
       if(ObjectFind("lvoe_tp_" + OrderTicket())==-1) {
       
        if(OrderTakeProfit()==0) {
         ObjectCreate("lvoe_tp_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderOpenPrice()+orderDir(OrderType())*default_tp_level*Point);
        } else {
         ObjectCreate("lvoe_tp_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderTakeProfit());
        }
        ObjectSet("lvoe_tp_" + OrderTicket(),OBJPROP_COLOR,tp_color); 
        ObjectSet("lvoe_tp_" + OrderTicket(),OBJPROP_STYLE,tp_style); 
       
       } else {
        align("lvoe_tp_" + OrderTicket());
        if(NormalizeDouble(OrderTakeProfit(),4)!=NormalizeDouble(ObjectGet("lvoe_tp_" + OrderTicket(),OBJPROP_PRICE1),4)) {
         if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),ObjectGet("lvoe_tp_" + OrderTicket(),OBJPROP_PRICE1),OrderExpiration(),CLR_NONE)) {
          //Alert(ErrorDescription(GetLastError()));
         }
         continue;
        }
       
       }  
      } else {
       if(ObjectFind("lvoe_tp_" + OrderTicket())!=-1) {
        ObjectDelete("lvoe_tp_" + OrderTicket());
       }
      }
      
      if(use_cp && cp_level>0) {
       if(ObjectFind("lvoe_cp_" + OrderTicket())==-1) {
        if(OrderType()==OP_BUY || OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) {
         if(OrderStopLoss()<OrderOpenPrice()) {
          ObjectCreate("lvoe_cp_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderOpenPrice()+cp_level*MarketInfo(OrderSymbol(),MODE_POINT));
          ObjectSet("lvoe_cp_" + OrderTicket(),OBJPROP_COLOR,cp_color); 
          ObjectSet("lvoe_cp_" + OrderTicket(),OBJPROP_STYLE,cp_style); 
         }
        } else {
         if(OrderStopLoss()>OrderOpenPrice()) {
          ObjectCreate("lvoe_cp_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderOpenPrice()-cp_level*MarketInfo(OrderSymbol(),MODE_POINT));
          ObjectSet("lvoe_cp_" + OrderTicket(),OBJPROP_COLOR,cp_color); 
          ObjectSet("lvoe_cp_" + OrderTicket(),OBJPROP_STYLE,cp_style); 
         }
        } 
       } else {
        if(OrderType()==OP_BUY) {
         if(MarketInfo(OrderSymbol(),MODE_BID)>ObjectGet("lvoe_cp_" + OrderTicket(),OBJPROP_PRICE1)) {
          if(OrderClose(OrderTicket(),cp_lots,MarketInfo(OrderSymbol(),MODE_BID),0)) {
           ObjectSet("lvoe_cp_" + OrderTicket(),OBJPROP_PRICE1,MarketInfo(OrderSymbol(),MODE_BID)+cp_closedlevel*MarketInfo(OrderSymbol(),MODE_POINT));
          }
          continue;
         }
        }
        if(OrderType()==OP_SELL) {
         if(MarketInfo(OrderSymbol(),MODE_ASK)<ObjectGet("lvoe_cp_" + OrderTicket(),OBJPROP_PRICE1)) {
          if(OrderClose(OrderTicket(),cp_lots,MarketInfo(OrderSymbol(),MODE_ASK),0)) {
           ObjectSet("lvoe_cp_" + OrderTicket(),OBJPROP_PRICE1,MarketInfo(OrderSymbol(),MODE_ASK)-cp_closedlevel*MarketInfo(OrderSymbol(),MODE_POINT));  
          }
          continue;
         }
        }
       }
      }
      
      if(use_be) {
       if(ObjectFind("lvoe_be_" + OrderTicket())==-1) {
        if(OrderType()==OP_BUY || OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) {
         if(OrderStopLoss()<OrderOpenPrice()) {
          ObjectCreate("lvoe_be_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderOpenPrice()+default_be_level*MarketInfo(OrderSymbol(),MODE_POINT));
          ObjectSet("lvoe_be_" + OrderTicket(),OBJPROP_COLOR,be_color); 
          ObjectSet("lvoe_be_" + OrderTicket(),OBJPROP_STYLE,be_style); 
         }
        } else {
         if(OrderStopLoss()>OrderOpenPrice()) {
          ObjectCreate("lvoe_be_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderOpenPrice()-default_be_level*MarketInfo(OrderSymbol(),MODE_POINT));
          ObjectSet("lvoe_be_" + OrderTicket(),OBJPROP_COLOR,be_color); 
          ObjectSet("lvoe_be_" + OrderTicket(),OBJPROP_STYLE,be_style); 
         }
        } 
       } else {
        if(OrderType()==OP_BUY) {
         if(MarketInfo(OrderSymbol(),MODE_BID)>ObjectGet("lvoe_be_" + OrderTicket(),OBJPROP_PRICE1)) {
          ObjectSet("lvoe_sl_" + OrderTicket(),OBJPROP_PRICE1,OrderOpenPrice()+be_offset*MarketInfo(OrderSymbol(),MODE_POINT));
          /*
          if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),OrderExpiration(),CLR_NONE)) {
           //Alert(ErrorDescription(GetLastError()));
          }
          */
          continue;
         }
        }
        if(OrderType()==OP_SELL) {
         if(MarketInfo(OrderSymbol(),MODE_ASK)<ObjectGet("lvoe_be_" + OrderTicket(),OBJPROP_PRICE1)) {
          ObjectSet("lvoe_sl_" + OrderTicket(),OBJPROP_PRICE1,OrderOpenPrice()-be_offset*MarketInfo(OrderSymbol(),MODE_POINT));
          /*
          if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),OrderExpiration(),CLR_NONE)) {
           //Alert(ErrorDescription(GetLastError()));
          }
          */
          continue;
         }
        }
       }
      }
      
      if(use_cl) {
       if(ObjectFind("lvoe_cl_" + OrderTicket())==-1) {
        if(OrderType()!=OP_BUY && OrderType()!=OP_SELL) {
         if(OrderType()==OP_BUY || OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) {
          ObjectCreate("lvoe_cl_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderOpenPrice()-default_cl_level*MarketInfo(OrderSymbol(),MODE_POINT));
          ObjectSet("lvoe_cl_" + OrderTicket(),OBJPROP_COLOR,cl_color); 
          ObjectSet("lvoe_cl_" + OrderTicket(),OBJPROP_STYLE,cl_style); 
         } else {
          ObjectCreate("lvoe_cl_" + OrderTicket(),OBJ_HLINE,0,Time[0],OrderOpenPrice()+default_cl_level*MarketInfo(OrderSymbol(),MODE_POINT));
          ObjectSet("lvoe_cl_" + OrderTicket(),OBJPROP_COLOR,cl_color); 
          ObjectSet("lvoe_cl_" + OrderTicket(),OBJPROP_STYLE,cl_style); 
         } 
        }
       } else {
        if(OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) {
         if(MarketInfo(OrderSymbol(),MODE_BID)<ObjectGet("lvoe_cl_" + OrderTicket(),OBJPROP_PRICE1)) {
          OrderDelete(OrderTicket());
         }
        }
        if(OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP) {
         if(MarketInfo(OrderSymbol(),MODE_ASK)>ObjectGet("lvoe_cl_" + OrderTicket(),OBJPROP_PRICE1)) {
          OrderDelete(OrderTicket());
         }
        }
        if(OrderType()==OP_BUY || OrderType()==OP_SELL) {
         ObjectDelete("lvoe_cl_" + OrderTicket());
        }
       }
      }
      
     }
      
    }
   }
      
   for(i=0;i<OrdersHistoryTotal();i++) {
    if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) {
     if(ObjectFind("lvoe_ol_" + OrderTicket())!=-1) {
      ObjectDelete("lvoe_ol_" + OrderTicket());
     }
     if(ObjectFind("lvoe_tp_" + OrderTicket())!=-1) {
      ObjectDelete("lvoe_tp_" + OrderTicket());
     }
     if(ObjectFind("lvoe_sl_" + OrderTicket())!=-1) {
      ObjectDelete("lvoe_sl_" + OrderTicket());
     }
     if(ObjectFind("lvoe_be_" + OrderTicket())!=-1) {
      ObjectDelete("lvoe_be_" + OrderTicket());
     }
     if(ObjectFind("lvoe_cl_" + OrderTicket())!=-1) {
      ObjectDelete("lvoe_cl_" + OrderTicket());
     }
     if(ObjectFind("lvoe_cp_" + OrderTicket())!=-1) {
      ObjectDelete("lvoe_cp_" + OrderTicket());
     }
    }
   }

}

void align(string name) {
 ObjectSet(name,OBJPROP_PRICE1,NormalizeDouble(ObjectGet(name,OBJPROP_PRICE1),Digits));
}

int orderDir(int oType) {

 if(oType==OP_BUY  || oType==OP_BUYLIMIT  || oType==OP_BUYSTOP) return(1);
 if(oType==OP_SELL || oType==OP_SELLLIMIT || oType==OP_SELLSTOP) return(-1);

}