//+------------------------------------------------------------------+
//|                                             MA Trailing Stop.mq4 |
//|                                       Copyright  2011, cosgrove |
//|                             http://www.forexfactory.com/cosgrove |
//| This EA will artificially trail your stop as the close of a bar  |
//| below/above the given MA settings in the Expert Properties.      |
//| No warranty; test it on demo first!                              |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, cosgrove"
#property link      "http://www.forexfactory.com/cosgrove"

//--- input parameters
extern int       MA_period=13;
extern int       MA_timeframe=5;
extern string    INFO_method="<0=sma,1=ema,2=smma,3=lwma>";
extern int       MA_method=0; // method 0-4 (sma, ema, smma, lwma)
extern string    INFO_appliedprice="<0=close,1=open,2=high,3=low,";
extern string    INFO_appliedpric3="4=median,5=typical,6=weighted>";
extern int       MA_applied_price=0; // applied price 0-6 (close, open, high, low, median, typ, weighted)
extern int       MA_shift=0;
extern string    INFO_slippage="<slippage in pippetts (10=1 pip)>";
extern int       allowed_slippage=10; // in pippetts

int init() { return(0);  }
int deinit() { return(0); }
int start() {
   double ma = NormalizeDouble(iMA(Symbol(),MA_timeframe,MA_period,MA_shift,MA_method,MA_applied_price,1),5);
   if (newBar()) {
      for(int i=OrdersTotal()-1;i>=0;i--) {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if ((OrderSymbol() == Symbol()) && (OrderType() == OP_BUY) && (OrderProfit() > 0) && (iClose(Symbol(),MA_timeframe,1) < ma) && (iOpen(Symbol(),MA_timeframe,1) >= ma))
            OrderClose(OrderTicket(),OrderLots(),Bid,allowed_slippage,Green);
         else if ((OrderSymbol() == Symbol()) && (OrderType() == OP_SELL) && (OrderProfit() > 0) && (iClose(Symbol(),MA_timeframe,1) > ma) && (iOpen(Symbol(),MA_timeframe,1) <= ma))
            OrderClose(OrderTicket(),OrderLots(),Ask,allowed_slippage,Green);
      }
   }
   return(0);
}

bool newBar()
{
   static datetime lastbar;
   datetime curbar = iTime(Symbol(),MA_timeframe,0);
   if(lastbar!=curbar)
   {
      lastbar=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
} 